load("@ytt:data", "data")
load("@ytt:regexp", "regexp")
load("@ytt:struct", "struct")
load("@ytt:assert", "assert")

def exclude_deps(values):
  return getattr(values, "exclude_dependencies", False) == True
end

scopes={
  "custom":[],
  "all":[
    "base-jammy-stack-lite.buildpacks.tanzu.vmware.com",
    "base-jammy-builder-lite.buildpacks.tanzu.vmware.com",
    "java-lite.buildpacks.tanzu.vmware.com",
    "dotnet-core-lite.buildpacks.tanzu.vmware.com",
    "go-lite.buildpacks.tanzu.vmware.com",
    "java-native-image-lite.buildpacks.tanzu.vmware.com",
    "nodejs-lite.buildpacks.tanzu.vmware.com",
    "python-lite.buildpacks.tanzu.vmware.com",
    "ruby-lite.buildpacks.tanzu.vmware.com",
    "web-servers-lite.buildpacks.tanzu.vmware.com"
  ],
  "stacks-only":[
    "base-jammy-stack-lite.buildpacks.tanzu.vmware.com",
    "base-jammy-builder-lite.buildpacks.tanzu.vmware.com"
  ]
}

def updates_allowed(values, name):
  dependency_updates = {
    "allow": False,
    "scope": "stacks-only",
    "exclude_packages": [],
    "include_packages": [],
  }

  if hasattr(values, "dependency_updates"):
    dependency_updates.update(struct.decode(values.dependency_updates))
  end
  dependency_updates = struct.encode(dependency_updates)

  if not dependency_updates.allow:
    return False
  end

  if dependency_updates.scope not in scopes.keys():
    assert.fail("invalid scope '{}', valid scopes are '{}'".format(dependency_updates.scope, scopes.keys()))
  end

  if name in dependency_updates.exclude_packages:
    return False
  end

  updateable_packages = scopes[dependency_updates.scope] + dependency_updates.include_packages

  return name in updateable_packages
end


def unpin_version(version):
  #! replace X.Y.Z with X.Y
  res = regexp.replace("([0-9]+\.[0-9]+)\.[0-9]+.*", version, "$1")

  #! append '.x' to X.Y, .x will allow any patch version in the X.Y major/minor
  return "{}.x".format(res)
end
