load("@ytt:data", "data")
load("@ytt:base64", "base64")
load("@ytt:json", "json")
load("@ytt:assert", "assert")
load("/helpers.star", "make_docker_config_json")
load("/validation.star", "validate")

validate()

### extract the docker registry from the repository string
kp_default_registry = "https://index.docker.io/v1/"
parts = data.values.kp_default_repository.split("/", 1)
if len(parts) == 2 and (('.' in parts[0] or ':' in parts[0]) and parts[0] != "index.docker.io"):
    kp_default_registry = parts[0]
end

### default image-pull config to pull_secret_export if none are set
pull_secret_export=data.values.pull_secret_export
# if any of these values are set, we should not assume that pull secret export should be used
if not (data.values.pull_from_kp_default_repo or data.values.tbs_source_registry or data.values.tbs_source_secret.name):
	pull_secret_export=True
end

### make docker creds

### kp_default_repository creds
empty_json_base64 = "e30="
kp_default_docker_configjson = empty_json_base64
kp_default_repository_secret = data.values.kp_default_repository_secret
kp_default_repository_secret_name = "kp-default-repository-secret"
if kp_default_repository_secret.name == "":
    kp_default_docker_configjson = make_docker_config_json(kp_default_registry, data.values.kp_default_repository_username, data.values.kp_default_repository_password)
else:
    kp_default_repository_secret_name = kp_default_repository_secret.name
end

### tbs_source creds
tbs_source_docker_configjson = empty_json_base64
tbs_source_secret = data.values.tbs_source_secret
tbs_source_registry = data.values.tbs_source_registry
tbs_source_registry_username = data.values.tbs_source_registry_username
tbs_source_registry_password = data.values.tbs_source_registry_password

if data.values.pull_from_kp_default_repo:
    if data.values.kp_default_repository_secret.name != "":
        tbs_source_secret = data.values.kp_default_repository_secret
    else:
		tbs_source_registry = kp_default_registry
		tbs_source_registry_username = data.values.kp_default_repository_username
		tbs_source_registry_password = data.values.kp_default_repository_password
    end
end

tbs_install_pull_secret_name = "tbs-install-pull-secret"
kpack_install_pull_secret_name = "kpack-install-pull-secret"
cert_injection_webhook_install_pull_secret_name = "cert-injection-webhook-install-pull-secret"
if tbs_source_secret.name == "":
	if not pull_secret_export: # do not make dockerconfig.json if using secret gen for pull secret
		tbs_source_docker_configjson = make_docker_config_json(tbs_source_registry, tbs_source_registry_username, tbs_source_registry_password)
	end
else:
	tbs_install_pull_secret_name = tbs_source_secret.name
	kpack_install_pull_secret_name = tbs_source_secret.name
	cert_injection_webhook_install_pull_secret_name = tbs_source_secret.name
end
